// C Header File
// Created 24/08/2002; 17:11:43
// copyright 2002 Thibaut Chevalier

#include "const.h" // constantes, librairies
#include "extgraph.h"
#include "title.h"

// Variables globales du programme
	void *Vscreen; // futur pointeur sur l'cran Virtuel
	INT_HANDLER save_int_1;	// variable utilise pour sauver l'tat de l'auto-interruption 1
	char *ptrNames = NULL;	// noms des fichiers de vaisseaux externes
	short nbExtShip;	// nombre de fichiers vaisseaux externes presents sur la caltos

// Prototypes de fonctions
	void enable_timer(void);
  void disable_timer(void);
  void free_sure(void*);
	void exit_proc(short);	// procdure de fin de programme


// Fonctions externes
	extern void alloc_arrays(void); 	// defini dans game.c
	extern void free_arrays(void); 	// defini dans game.c
	extern void open_hsc(void); 	// defini dans highscores.c
	extern void close_hsc(void);	// defini dans highscores.c
	extern short run_menu(short);	// defini dans menu.c
	extern void ship_set(short, short, short, short, short, short, short); // defini dans game.c