// C Source File
// Created 07/11/2002; 23:08:25

#include "menu.h"


// fonction d'affichage de texte
void drawTextPage(TextPage* ptrText)
{
	short i;
	for (i = 0; i < ptrText->linesNum; i++)
		DrawStr(ptrText->coord[i][0], ptrText->coord[i][1], ptrText->message[i], A_NORMAL);
}


short run_menu(short menuID)
{
	short ship, key_down, linesNum, currentLine = 0, forcingNb, mod;
	TextPage *ptrText;
	unsigned char arrow_sprt[] = {0x24, 0x42, 0x99, 0xff, 0x99, 0x42, 0x24}; // Sprite "flche"

/***************************** initialisation de l'cran ************************************/
restart:

	camera_set(0, 0, 50);
	ClrScr();
	FastDrawLine(Vscreen, 0, 30, LCD_WIDTH - 1, 30, A_NORMAL);
	FastDrawLine(Vscreen, 0, LCD_HEIGHT - 8, LCD_WIDTH - 1, LCD_HEIGHT - 8, A_NORMAL);	
		
/*********************************************************************************************/	
	
	if (menuID < REAL_MENUS_NB) // Si le menu est un vrai menu
		{
		ptrText = Menus[menuID].ptrTextPage; // Rcuprer l'adresse de la page de Texte
		drawTextPage(ptrText); // Dessiner le texte du menu
		linesNum = (ptrText->linesNum); // rcuprer et stocker le nombre de lignes du menu
		
		if (menuID <= OPTIONS_MENU_ID)
			{
			#ifdef COMPILE_FOR_TI89			// dessine le XWing  l'cran
				/*set_screen_center((LCD_WIDTH / 2) + 39, LCD_HEIGHT / 2);
				ship_set(7, 0, -13, -15, 210, 173, 217);
				draw_intro_ship(7);*/
				set_screen_center(119, 50);
				ship_set(3, 0, -13, -22, 10, 136, 239);
				draw_intro_ship(3);
				set_screen_center(124, 47);
				ship_set(4, 16, 6, -42, 238, 143, 248);
				draw_intro_ship(4);
			#endif
			#ifdef COMPILE_FOR_TI92PLUS	// dessine le XWing et le YWing
				set_screen_center((LCD_WIDTH / 2) - 75, LCD_HEIGHT / 2 - 8);
				ship_set(3, 0, -13, -22, 23, 0, 215);
				draw_intro_ship(3);
				set_screen_center((LCD_WIDTH / 2) + 75, LCD_HEIGHT / 2);
				ship_set(4, 0, -13, -22, 210, 100, 38);
				draw_intro_ship(4);
			#endif
			}
		
		set_screen_center(LCD_WIDTH / 2, 10);
		
		Sprite8_OR(1 + SPEOFFSET, ptrText->coord[currentLine][1] - 1, 7, arrow_sprt, Vscreen);	// aficche le curseur en position initiale
		DrawStr(0, LCD_HEIGHT - 6, Menus[menuID].statusBarText[currentLine], A_NORMAL); // Affiche le message qui va avec le menu point par le curseur en bas dans la barre de statut
		key_down = 1;
		while (1)
			{
			while (!(_keytest(RR_ENTER2) && !key_down))
				{
				if (!_rowread(0x00)) key_down = 0;	// si aucune touche presse, changer key_down

				anim_title(); // animer le titre
			
				if (_keytest(RR_ESC) && !key_down) return(1);	// revenir au menu prcedent;		
									
				// descend le curseur
				if (_keytest(RR_DOWN) && !key_down)
					{
					Sprite8_XOR(1 + SPEOFFSET, ptrText->coord[currentLine][1] - 1, 7, arrow_sprt, Vscreen); // effacer le curseur  son emplacement actuel
					currentLine++;
					if (currentLine == linesNum) currentLine = 0; // faire le rebouclage si le curseur descend en dessous de la la dernire ligne
					Sprite8_XOR(1 + SPEOFFSET, ptrText->coord[currentLine][1] - 1, 7, arrow_sprt, Vscreen); // dessiner le cursur  son nouvel emplacement
					key_down = 1; // message : touche prsse (et la lecture des touches est inactive jusqu'a ce que la touche soit relache)
					memset(Vscreen + (LCD_HEIGHT - 6)*30, 0, 6*30); // efface le bas de l'cran
					DrawStr(0, LCD_HEIGHT - 6, Menus[menuID].statusBarText[currentLine], A_NORMAL); // Affiche le message qui va avec le menu point par le curseur en bas dans la barre de statut
					}
				// monte le curseur
				if (_keytest(RR_UP) && !key_down)
					{
					Sprite8_XOR(1 + SPEOFFSET, ptrText->coord[currentLine][1] - 1, 7, arrow_sprt, Vscreen); // effacer le curseur  son emplacement actuel
					currentLine--;
					if (currentLine == -1) currentLine = linesNum - 1; // faire le rebouclage si le curseur monte au dessus de la premire ligne
					Sprite8_XOR(1 + SPEOFFSET, ptrText->coord[currentLine][1] - 1, 7, arrow_sprt, Vscreen); // dessiner le cursur  son nouvel emplacement
					key_down = 1; // message : touche prsse (et la lecture des touches est inactive jusqu'a ce que la touche soit relache)
					memset(Vscreen + (LCD_HEIGHT - 6)*30, 0, 6*30); // efface le bas de l'cran
					DrawStr(0, LCD_HEIGHT - 6, Menus[menuID].statusBarText[currentLine], A_NORMAL); // Affiche le message qui va avec le menu point par le curseur en bas dans la barre de statut
					}
				}	// fin du while
			// ici donc enter  t press
			forcingNb = run_menu(Menus[menuID].links[currentLine]); // appelle le menu choisi : c'est ici que se trouve la RECURSIVIT
			if (--forcingNb) return(forcingNb);	// si il y a demande de forcer le retour au menu prcedent, retour au menu appellant
			goto restart;
			}	// fin du while 1 (on sort de cette boucle avec un return)
		} // fin du if
	else	// si le menu est un menu terminal
		{
		switch (menuID) // tester l'identificateur de menu terminal
			{
			case CONTROLS_MENU_ID:
			drawTextPage(&keysPage);
			while (_keytest(RR_ENTER2) || _keytest(RR_ESC)) anim_title(); // attendre que enter soit relache
			while (!(_keytest(RR_ESC) || _keytest(RR_ENTER2))) anim_title(); // attendre l'appui sur la touche 'sortir'
			return(1);
			
			case HIGH_MENU_ID:
			mod = optionsData.controlsMode;
			set_screen_center(LCD_WIDTH / 2, 10);
			disp_hsc_tabl(mod - 1);
			
			while (_keytest(RR_ENTER2) || _keytest(RR_ESC)) anim_title(); // attendre que enter/esc soit relache
			while (!(_keytest(RR_ESC) || _keytest(RR_ENTER2)))
				{
				anim_title();
				if (_keytest(RR_LEFT) || _keytest(RR_RIGHT)) 
					{
					mod = 3 - mod;
					ClrScr();
					FastDrawLine(Vscreen, 0, 30, LCD_WIDTH - 1, 30, A_NORMAL);
					FastDrawLine(Vscreen, 0, LCD_HEIGHT - 8, LCD_WIDTH - 1, LCD_HEIGHT - 8, A_NORMAL);	
					disp_hsc_tabl(mod - 1);
					while (_rowread(0x00)) anim_title(); // attendre que toutes les touches soient relaches
					}
				}
			return(1);
			
			case CREDITS_MENU_ID:
			drawTextPage(&creditsPage);
			DrawStr(XOFFSET + 37, LCD_HEIGHT - 6, "http://www.moitib.fr.st/", A_NORMAL); // affiche le footer
			memcpy(LCD_MEM + 30 * (LCD_HEIGHT - 6), Vscreen + 30 * (LCD_HEIGHT - 6), 30 * 6);
			while (_keytest(RR_ENTER2) || _keytest(RR_ESC)) anim_title(); // attendre que enter soit relache
			while (!(_keytest(RR_ESC) || _keytest(RR_ENTER2))) anim_title(); // attendre l'appui sur la touche 'sortir'
			return(1);
			
			case EXIT_MENU_ID:
			while(_keytest(RR_ENTER2));
			exit_proc(0);	// terminer le programme
			
			case CHGNAME_MENU_ID:
			memset(LCD_MEM + (LCD_HEIGHT - 7) * 30, 0, 7 * 30); // efface le bas de l'cran (du vrai)
			DrawStr(0, LCD_HEIGHT - 6, "Enter your name : ", A_NORMAL); // remplacer temporairement le footer
			while (_keytest(RR_ENTER2)); // attendre que la touche ENTER soit relache
			input_str(optionsData.playerName);
			copy_game_options();
			return(1);
			
			case CTMOD_MENU_ID:
			optionsData.controlsMode = 3 - optionsData.controlsMode;	// arcade -> simulation ou simulation -> arcade
			copy_game_options();
			return(1);
				
			case TRAJ_MENU_ID:
			optionsData.trajMode = 3 - optionsData.trajMode;	// lignes -> spirales ou spirales -> lignes
			copy_game_options();
			return(1);
			
			case DEF_CAM_MENU_ID:
			if (optionsData.cameraMode == FIX) optionsData.cameraMode = MOBILE;
			else optionsData.cameraMode = FIX;
			//optionsData.cameraMode = 3 - optionsData.cameraMode;	// FIX -> MOBILE ou MOBILE -> FIX
			copy_game_options();
			return(1);
			
			case COMPET_MENU_ID:
			if (*optionsData.playerName == '_')
				{
				DrawStr(15 + XOFFSET, LCD_HEIGHT - 6, "... You have not entered you name ...", A_NORMAL);
				while (_keytest(RR_ENTER2)) anim_title(); // attendre que enter soit relache
				while(!_rowread(0x00)) anim_title();
				return(1);
				}	// Affiche un warning et revient au menu prcedent
			ship = ship_selection();
			if (ship == -1)
				{
				for (ship = 0; ship <= 1; ship++) 
				INIT_TIE;
				return(1);	// il y a eu appui sur esc dans l'cran de selection des vaisseaux
				}
			game(ship, COMPET);
			for (ship = 0; ship <= 1; ship++) 
			INIT_TIE;
			run_menu(HIGH_MENU_ID);
			return(2);
			/* forcer le retour de 2 menu
			- compet
			-> play
			-> main */
			
			case TRAINING_MENU_ID:
			ship = ship_selection();
			if (ship == -1) 
				{
				for (ship = 0; ship <= 1; ship++) 
				INIT_TIE;
				return(1);	// il y a eu appui sur esc dans l'cran de selection des vaisseaux
				}
			game(ship, TRAINING);
			for (ship = 0; ship <= 1; ship++) 
			INIT_TIE;
			return(2);
			/* forcer le retour de 2 menu
			- compet
			-> play
			-> main */
			
			}
		}
	return(1);
}



void anim_title(void)
{
	short ship, i;
	
	memset(Vscreen, 0, 29 * 30); // efface le haut de l'cran
	
	for (i = 0; i < 23; i++) memcpy(Vscreen + 64 + (XOFFSET/8) + 30 * i, title_pic + 12*i, 12);	// affiche l'image
	FontSetSys(F_4x6);
	DrawStr(LCD_WIDTH / 2 - 18, 24, "beta v0.8", A_NORMAL);
	
	for (ship = 0; ship <= 1; ship++) 
		{
		draw_intro_ship(ship); // affiche les deux TIE  gauche et  droite du titre
		turn_ship_y(ship);
		}
	// Copie l'cran virtuel dans lequel on a crit sur le LCD
	memcpy(LCD_MEM, Vscreen, LCD_SIZE); // Affiche d'un coup l'cran virtuel (et ainsi il n'y a pas de dlai entre l'affichage des premires et des dernires lignes	
}


// Saisie de nom de 8 lettres. Merci  Zeljko Juric dans Cave Blaster
void input_str(char *str)
{
  int i = 0, key = 0;
  
  ClrScr();	// efface l'cran virtuel (ca ne change rien  l'cran pour l'instant)
  enable_timer(); // ceci pour permettre le fonctionnement de ngetchx
  
  while(key!=13)
    {
    str[i]='_'; str[i+1]=' '; str[i+2]=' '; str[i+3]=0;
    memset(Vscreen, 0, 7*30); // efface le haut de l'cran virutel (on va y crire et on veut que ca soit propre !)
    DrawStr(0, 1, "Enter your name : ", A_NORMAL);
    DrawStr(63, 1, str,A_REPLACE);
    memcpy(LCD_MEM + (LCD_HEIGHT - 7)*30, Vscreen, 7*30); // copie les changements en bas de l'cran rel
    key=ngetchx();	// rcuprer le caractre
    if(key >= ' ' && key <= '~' && i < 8) str[i++] = key;
    if(key == 257 && i) i--;
		}
	str[i] = 0; // ajouter le zro terminal au string
	
	disable_timer();
}


void copy_game_options(void)
{
// Ces instructions produisent des warning : en fait j'cris sur une zone de mmoire alloue pour contenir des const char
	memcpy(Menus[PLAY_MENU_ID].statusBarText[2] + 15, optionsData.playerName, 8); // recopier le nouveau nom dans la zone de texte : "Current name : ________" du menu play
	memcpy(Menus[OPTIONS_MENU_ID].statusBarText[0] + 15, optionsData.playerName, 8); // recopier le nouveau nom dans la zone de texte : "Current name : ________"	du menu options					
	
	if (optionsData.controlsMode == ARCADE) sprintf(Menus[OPTIONS_MENU_ID].statusBarText[1] + 15, "Arcade");
	else sprintf(Menus[OPTIONS_MENU_ID].statusBarText[1] + 15, "Simulation");
	if (optionsData.trajMode == LINE) sprintf(Menus[OPTIONS_MENU_ID].statusBarText[2] + 21, "Line");
	else sprintf(Menus[OPTIONS_MENU_ID].statusBarText[2] + 21, "Helicoid");
	if (optionsData.cameraMode == FIX) sprintf(Menus[OPTIONS_MENU_ID].statusBarText[3] + 30, "Fixed");
	else sprintf(Menus[OPTIONS_MENU_ID].statusBarText[3] + 30, "Ship-locked");
	
	
}