// C Header File
// Created 16/11/2002; 16:10:32
// C Header File
// Created 27/08/2002; 23:17:15
// Dfinitions des objets 3D

	short noEnds[] = {-1};

/**************************** Dfinition du TIE fighter ****************************/

// Definition des vertices (20)
#define TIEF_VERT_NB 20
	Vertex tieFVertices[20] = {{0,5,0},{5,0,0},{0,-5,0},{-5,0,0},{0,0,5},{0,0,-5},{10,0,0},{8,10,5},{8,10,-5},{8,0,-8},{8,-10,-5},{8,-10,5},{8,0,8},{-10,0,0},{-8,10,5},{-8,10,-5},{-8,0,-8},{-8,-10,-5},{-8,-10,5},{-8,0,8}};
											
// Dfinition des lignes qui joignent les vertices (34)
#define TIEF_LINES_NB 34
	Line tieFLines[34] = 		{{0,4},{4,2},{2,5},{5,0}, 			//
													{0,1},{4,1},{2,1},{5,1}, 				// corps
													{0,3},{4,3},{2,3},{5,3}, 				//
													{1,6},{3,13},			 				// bras
													{7,8},{8,9},{9,10},{10,11},{11,12},{12,7},{6,7},{6,8},{6,10},{6,11},			// aile
													{14,15},{15,16},{16,17},{17,18},{18,19},{19,14},{13,14},{13,15},{13,17},{13,18}};			// aile
	
// Extrmits de l'objet
	short tieFEnds[] = {6, 8, 10, 12, 14, 16, 18};	
	short tieFCanons[] = {1, 3};	

/**************************** Dfinition du TIE interceptor ****************************/

// Definition des vertices (28)
#define TIEI_VERT_NB 28
	Vertex tieIVertices[28] = {{0,5,0},{5,0,0},{0,-5,0},{-5,0,0},{0,0,5},{0,0,-5},{10,0,0},{10,3,0},{10,3,6},{10,-3,6},{10,-3,0},{10,-3,-15},{8,-10,0},{8,-10,4},{8,10,4},{8,10,0},{10,3,-15},{-10,0,0},{-10,3,0},{-10,3,6},{-10,-3,6},{-10,-3,0},{-10,-3,-15},{-8,-10,0},{-8,-10,4},{-8,10,4},{-8,10,0},{-10,3,-15}};
											
// Dfinition des lignes qui joignent les vertices (42)
#define TIEI_LINES_NB 42
	Line tieILines[42] = 		{{0,4},{4,2},{2,5},{5,0}, 			//
													{0,1},{4,1},{2,1},{5,1}, 				// corps
													{0,3},{4,3},{2,3},{5,3}, 				//
													{1,6},{3,17},			 				// bras
													{7,8},{8,9},{9,10},{10,7},{7,15},{15,14},{14,8},{15,16},{7,16},{10,12},{12,13},{13,9},{10,11},{11,12}, // aile gauche
													{18,19},{19,20},{20,21},{21,18},{19,25},{25,26},{26,27},{27,18},{18,26},{20,24},{24,23},{23,22},{22,21},{21,23}}; // aile droite
													
	
// Extrmits de l'objet
	short tieIEnds[] = {8, 11, 16, 13, 14, 22, 27, 23, 26};	
	short tieICanons[] = {1, 3};
	
/********************* Dfinition de la navette Tydirium (Lambda-class shuttle) **********************/

// Definition des vertices (23)
#define TYDI_VERT_NB 23
	Vertex tydiVertices[23] = {{0,0,5},{7,0,5},{7,-2,5},{0,-2,5},{-7,-2,5},{-7,0,5},{0,3,5},
														{4,0,-10},{4,-2,-10},{-4,-2,-10},{-4,0,-10},{0,3,-5},
														{0,6,-8},{0,18,-3},{0,18,5},
														{7,-5,5},{17,-17,2},{17,-17,-5},{7,-5,-5},
														{-7,-5,5},{-17,-17,2},{-17,-17,-5},{-7,-5,-5}};
											
// Dfinition des lignes qui joignent les vertices (34)
#define TYDI_LINES_NB 34
	Line tydiLines[34] = 		{{1,2},{2,4},{4,5},{5,1},{7,8},{8,9},{9,10},{10,7},{0,3},{1,7},{2,8},{4,9},{5,10},{1,6},{5,6},{6,11},{10,11},{7,11}, // corps
													{11,12},{12,13},{13,14},{14,6},									// aile du milieu
													{2,15},{8,18},{15,18},{15,16},{16,17},{17,18}, 	// aile gauche
													{4,19},{9,22},{19,22},{19,20},{20,21},{21,22}}; // aile droite
														
// Extrmits de l'objet
	short tydiEnds[] = {9, 13, 14, 16, 17, 20, 21, 3, 7, 10};	
	short tydiCanons[] = {7, 10};	

/**************************** Dfinition du XWing ****************************/

// Definition des vertices
#define XWING_VERT_NB 42  
	Vertex xWingVertices[42] = {{-2,0,-20},{2,0,-20},	// bouts du nez
															{-7,2,0},{-5,4,0},{-3,2,0},{3,2,0},{5,4,0},{7,2,0},{5,0,0},{7,-2,0},{5,-4,0},{3,-2,0},{-3,-2,0},{-5,-4,0},{-7,-2,0},{-5,0,0}, // contour de la facade avant
															{-7,2,10},{-5,4,10},{-3,2,10},{3,2,10},{5,4,10},{7,2,10},{7,-2,10},{5,-4,10},{3,-2,10},{-3,-2,10},{-5,-4,10},{-7,-2,10},{-5,0,10}, // contour de la facade arrire
															{-30,5,8},{-30,5,2},{-30,5,-5}, 	// bout de l'aile gauche haute
															{-30,-5,8},{-30,-5,2},{-30,-5,-5},// bout de l'aile gauche basse
															{30,5,8},{30,5,2},{30,5,-5}, 			// bout de l'aile droite haute
															{30,-5,8},{30,-5,2},{30,-5,-5},  	// bout de l'aile droite basse
															{5,0,10}};	// point que j'ai oubli dans le contour arrire...
											
// Dfinition des lignes qui joignent les vertices
#define XWING_LINES_NB 61
	Line xWingLines[61] = 	{{0,1},{0,4},{0,15},{0,12},{1,5},{1,8},{1,11}, 												// nez
													{2,3},{3,4},{4,5},{5,6},{6,7},{9,10},{10,11},{11,12},{12,13},{13,14}, // facade racteurs avant
													{14,4},{2,12},{5,9},{7,11},																						// croix racteurs avant
													{16,17},{17,18},{18,19},{19,20},{20,21},{22,23},{23,24},{24,25},{25,26},{26,27}, // facade racteurs arrire
													{16,25},{18,27},{19,22},{21,24},																			// croix racteurs arrire
													{16,29},{2,30},{29,31},		// aile gauche haute
													{27,32},{14,33},{32,34},  // aile gauche basse
													{21,35},{7,36},{35,37},		// aile droite haute
													{22,38},{9,39},{38,40},		// aile droite basse
													{2,16},{3,17},{4,18},{5,19},{6,20},{7,21},{8,41},{9,22},{10,23},{11,24},{12,25},{13,26},{14,27},{15,28}}; // liaisons facade avant / facade arrire
													
	
// Extrmits de l'objet
	short xWingEnds[] = {12,0,1,29,31,32,34,35,37,38,40,28,41};	
	short xWingCanons[] = {31,37};
		
/**************************** Dfinition du YWing ****************************/

// Definition des vertices
#define YWING_VERT_NB 44  
	Vertex yWingVertices[44] = {{3,-3,-30},{-3,-3,-30},{-4,-3,-25},{-9,-1,-10},{-4,0,-5},{4,0,-5},{9,-1,-10},{4,-3,-25},{-9,-5,-10},{-4,-5,-5},{4,-5,-5},{9,-5,-10},{4,0,20},{-4,0,20}, // cabine
															{-10,0,13},{-10,0,10},{10,0,10},{10,0,13},	// structure arrire
															{-13,3,3},{-16,2,3},{-16,-2,3},{-13,-3,3},{-10,-2,3},{-10,2,3}, // facade avant racteur gauche
															{-13,3,20},{-16,2,20},{-16,-2,20},{-13,-3,20},{-10,-2,20},{-10,2,20}, // facade arrire racteur gauche
															{13,3,3},{16,2,3},{16,-2,3},{13,-3,3},{10,-2,3},{10,2,3}, // facade avant racteur droit
															{13,3,20},{16,2,20},{16,-2,20},{13,-3,20},{10,-2,20},{10,2,20}, // facade arrire racteur droit
															{3,-3,-25},{-3,-3,-25}}; // extremits des canons que j'ai oubli au debut...

											
// Dfinition des lignes qui joignent les vertices
#define YWING_LINES_NB 62
	Line yWingLines[62] = 	{{0,42},{1,43},{2,7},{2,8},{8,9},{9,10},{10,11},{11,7},{2,3},{3,4},{4,5},{5,6},{6,7},{3,8},{4,9},{5,10},{6,11}, // cabine
													{12,13},{13,4},{13,9},{12,5},{12,10},	// structure arrire
													{14,15},{15,16},{16,17},{17,14},			// porte-racteurs
													{18,19},{19,20},{20,21},{21,22},{22,23},{23,18},	// facade avant racteur gauche
													{24,25},{25,26},{26,27},{27,28},{28,29},{29,24},	// facade arrire racteur gauche
													{18,24},{19,25},{20,26},{21,27},{22,28},{23,29},  // liaisons inter facades racteur gauche
													{30,31},{31,32},{32,33},{33,34},{34,35},{35,30},	// facade avant racteur droit
													{36,37},{37,38},{38,39},{39,40},{40,41},{41,36},	// facade arrire racteur droit
													{30,36},{31,37},{32,38},{33,39},{34,40},{35,41}};	// liaisons inter facades racteur droit
													
	
// Extrmits de l'objet
	short yWingEnds[] = {12,0,1,2,3,6,7,20,31,25,37,12,13};	
	short yWingCanons[] = {0,1};

/**************************** Dfinition du Faucon Millenium ****************************/

// Definition des vertices (32)
#define FAUC_VERT_NB 32
	Vertex faucVertices[32] = {{2,4,0},{-2,4,0},{-2,2,-20},{2,2,-20},{2,-3,-20},{2,0,-15},{-2,-3,-20},{-2,0,-15},{-15,0,-10},{-20,0,0},{-15,0,10},{-5,0,15},{5,0,15},{15,0,10},{20,0,0},{15,0,-10},{7,0,-30},{2,0,-30},{-2,0,-30},{-7,0,-30},{-15,-4,-10},{-20,-4,0},{-15,-4,10},{-5,-4,15},{5,-4,15},{15,-4,10},{20,-4,0},{15,-4,-10},{7,-2,-30},{2,-2,-30},{-2,-2,-30},{-7,-2,-30}};
											
// Dfinition des lignes qui joignent les vertices (58)
#define FAUC_LINES_NB 58
	Line faucLines[58] = 		{{0,1},{1,2},{2,3},{3,0},{3,4},{2,6},
													{7,18},{18,19},{19,8},{8,9},{9,10},{10,11},{11,12},{12,13},{13,14},{14,15},{15,16},{16,17},{17,5},{15,5},{7,8},
													{0,5},{1,7},{1,8},{1,9},{1,10},{1,11},{0,12},{0,13},{0,14},{0,15},{0,5},
													{4,6},{6,30},{30,31},{31,20},{20,21},{21,22},{22,23},{23,24},{24,25},{25,26},{26,27},{27,28},{28,29},{29,4},
													{8,20},{9,21},{10,22},{11,23},{12,24},{13,25},{14,26},{15,27},{16,28},{17,29},{18,30},{19,31}};
														
// Extrmits de l'objet
	short faucEnds[] = {7, 16, 31, 9, 26, 12, 23, 0};	
	short faucCanons[] = {8,15};	

/**************************** Dfinition de l'avion ****************************/

// Definition des vertices (26)
#define PLANE_VERT_NB 26
	Vertex planeVertices[26] = {{0,-4,-30}, 													// bout du nez
												{4,0,-20},{0,4,-20},{-4,0,-20},{0,-4,-20},	// anneau avant
												{4,0,0},{4,0,10},{20,0,20},{20,0,15},				// aile droite
												{-4,0,0},{-4,0,10},{-20,0,20},{-20,0,15},		// aile gauche
												{4,0,20},{0,4,20},{-4,0,20},{0,-4,20},			// anneau arrire
												{0,10,25},{0,10,27},{0,10,30},							// milieu de l'aileron
												{8,10,30},{8,10,25},{-8,10,25},{-8,10,30},	// coins de l'aileron
												{10,0,5},{-10,0,5}};	// points "canon"


// Dfinition des lignes qui joignent les vertices (30)
#define PLANE_LINES_NB 30
	Line planeLines[30] = {{0,1},{0,2},{0,3},{0,4}, 			// nez
											{1,2},{2,3},{3,4},{4,1}, 					// anneau avant
											{1,13},{2,14},{3,15},{4,16}, 			// corps
											{13,14},{14,15},{15,16},{16,13},	// anneau arrire
											{6,7},{7,8},{8,5},								// aile droite
											{10,11},{11,12},{12,9},						// aile gauche
											{13,18},{14,17},{15,18},{16,19},	// queue
											{20,21},{21,22},{22,23},{23,20}};	// aileron
											
	short planeEnds[] = {8, 0, 7, 8, 11, 12, 16, 20, 23};
	short planeCanons[2] = {24, 25};

/**************************** Dfinition du F-14 ****************************/

// Definition des vertices (43)
#define F14_VERT_NB 43
	Vertex f14Vertices[43] = {{0,0,-32},{2,2,-25},{-2,2,-25},{-2,-2,-25},{2,-2,-25},{2,-2,-5},{2,2,5},{-2,2,-5},{-2,-2,-5},{2,4,-15},{-2,4,-15},{7,-1,20},{7,2,20},{-7,2,20},{-7,-1,20},
														{22,2,10},{20,2,15},{2,2,5},{-2,2,5},{-20,2,15},{-22,2,10},{-7,2,-5},{7,12,22},{6,12,15},{5,2,10},{-7,12,22},{-6,12,15},{-5,2,10},{12,0,22},{14,0,20},{5,0,10},{7,0,20},
														{2,2,-15},{-2,2,-15},{7,2,-5},{-12,0,22},{-14,0,20},{-5,0,10},{-7,0,20},{4,2,20},{4,-1,20},{-4,2,20},{-4,-1,20}};
																										
												


// Dfinition des lignes qui joignent les vertices (50)
#define F14_LINES_NB 50
	Line f14Lines[50] = {{0,1},{0,2},{0,3},{0,4},{4,5},{1,6},{2,7},{3,8},
														{5,11},{11,14},{14,8},{6,12},{12,13},{13,7},
														{1,2},{2,3},{3,4},{4,1},{11,12},{13,14},
														{1,9},{9,6},{2,10},{10,7},{9,10}, // cockpit
														{32,34},{34,15},{15,16},{16,17},{17,18},{18,19},{19,20},{20,21},{21,33}, // grande aile
														{22,23},{23,24},{22,12}, // ailerons arrires verticaux
														{25,26},{26,27},{25,13},
														{28,29},{29,30},{30,31},{31,28}, // ailerons arriere horizontaux
														{35,36},{36,37},{37,38},{38,35},
														{39,40},{41,42}}; // lignes verticales des racteurs
											
	short f14Ends[] = {10,0,34,15,20,21,35,28,22,25,6};
	short f14Canons[2] = {21,34};

/**************************** Dfinition du rafale ****************************/

// Definition des vertices (44)
#define RAF_VERT_NB 44
	Vertex rafVertices[44] = {{0,0,-30},{0,0,-25},{2,2,-20},{-2,2,-20},{-2,-2,-20},{2,-2,-20},{-1,1,15},{-2,1,15},{-1,-2,15},{1,-2,15},
														{2,1,15},{1,1,15},{1,1,25},{-2,1,15},{-2,2,25},{-4,0,25},{-2,-2,25},{2,-2,25},{4,0,25},{2,2,25},
														{-2,2,15},{-4,0,15},{-2,-2,15},{2,-2,15},{4,0,15},{2,2,15},{0,1,25},{0,10,28},{0,10,25},{0,1,12},
														{2,0,-10},{15,0,15},{15,0,17},{15,0,20},{4,0,20},{-4,0,20},{-15,0,20},{-15,0,17},{-15,0,15},{-2,0,-10},
														{2,4,-10},{-2,4,-10},{2,2,0},{-2,2,0}};
																										
// Dfinition des lignes qui joignent les vertices (53)
#define RAF_LINES_NB 53
	Line rafLines[53] = {{0,1},{1,2},{1,3},{1,4},{1,5},{2,10},{3,7},{4,8},{5,9},{6,7},
												{10,11},{11,12},{12,13},{13,6},{13,14},{14,15},{15,16},{16,17},{17,18},{18,19},
												{19,12},{6,20},{20,21},{21,22},{22,23},{23,24},{24,25},{25,11},{14,20},{15,21},
												{16,22},{17,23},{18,24},{19,25},{26,27},{27,28},{28,29},
												{30,32},{31,33},{33,34},{34,30},
												{35,36},{36,38},{37,39},{39,35},
												{2,40},{40,42},{42,43},{40,41},{3,41},{41,43},
												{14,17},{16,19}};
											
	short rafEnds[] = {11,0,2,4,31,33,38,36,18,25,27,28};
	short rafCanons[2] = {31,38};


/**************************** Dfinition du deltaplane ****************************/

// Definition des vertices (19)
#define DELTA_VERT_NB 19
	Vertex deltaVertices[19] = {{0,5,-10},{-20,5,10},{20,5,10},{-5,5,-5},{5,5,-5},{-3,-5,-5},{3,-5,-5},{-2,-5,0},{2,-5,0},{2,-5,10},{-2,-5,10},{-2,-7,0},{2,-7,0},{2,-7,10},{-2,-7,10},{0,5,8},{0,-5,8},{0,-5,-3},{0,-2,0}};
											
// Dfinition des lignes qui joignent les vertices (26)
#define DELTA_LINES_NB 26
	Line deltaLines[26] = 	{{0,1},{1,2},{2,0},					// voile
													{3,5},{5,6},{6,4},					// barre
													{5,7}, {6,8},								// bras
													{7,8},{8,9},{9,10},{10,7}, 				//
													{11,12},{12,13},{13,14},{14,11}, 	// corps
													{7,11},{8,12},{9,13},{10,14}, 		//
													{15,16},										// fil
													{7,17},{8,17},{17,18},{7,18},{8,18}}; 	// tte
	
// Extrmits de l'objet
	short deltaEnds[] = {7, 0, 1, 2, 5, 6, 9, 10};
	short deltaCanons[] = {5,6};


/***************************** Dfinition du missile guid (qui est comme un vaisseau) ****************************/

// Definition des vertices (13)
#define MISSG_VERT_NB 13
	Vertex missileGVertices[13] = {{0,2,10},{2,0,10},{0,-2,10},{-2,0,10},{0,2,-6},{2,0,-6},{0,-2,-6},{-2,0,-6},{0,0,-10},{-2,0,2},{-4,0,10},{2,0,2},{4,0,10}};
											
// Dfinition des lignes qui joignent les vertices (20)
#define MISSG_LINES_NB 20
	Line missileGLines[20] = {{0,1},{1,2},{2,3},{3,0},{4,5},{5,6},{6,7},{7,4},{8,4},{8,5},{8,6},{8,7},{0,4},{1,5},{2,6},{3,7},{9,10},{10,3},{11,12},{12,1}};
	
	short missileGEnds[] = {3, 8, 10, 12};	// extrmits du missile guid

	Angle missileGAng;
	Vertex missileGCentre;
	short missileGDist;	  // nombre de pas parcourus par le missile guid
	short missileGstock;  // stock restant de missiles guids
	short missileGflicker; // variable utilise pour signaler l'arrive du nouveau missile


/**************** Dfinition des tableaux qui contient des pointeurs sur les infos des vaisseaux ***************/
#define SHIP_NB 10		// nombre de vaisseaux inclus dans le jeu
#define MISS_NB (SHIP_NB + 1)
#define EXT_SHIP_NB SHIP_NB
#define MAX_POINTS 44 		// Maximum de points dans un objet (tous objets confondus) pour les vaisseaux par dfaut


	short shipClass[] = {1, 1, 1, 1, 1, 1, 2, 2, 2, 0, 3};
	const char* classNames[] = {"- Miscellaneous -", "- The Star Wars serie -", "- Planes serie -", "- Edited Ships -"};
	short classNamesShift[] = {-33, -40, -29 ,-31}; 
  const char* shipNames[] = {"TIE Fighter", "TIE Interceptor", "\x89-Class Shuttle", "XWing", "YWing", "Millenium Falcon", "Light Plane", "F-14", "Rafale", "Hang-glider", "        "};
	short shipNamesShift[] = {-34, -45, -45, -15, -15, -48, -35, -14, -19, -36, -20};
	float shipSizeBonus[] = {0.4 ,0.5, 1.4, 1.9, 1.2, 1, 1.9, 1.3, 1.3, 0.5, 0};
	// {1.1, 1.5, 2.8, 2.5, 2.5, 2.4, 2.5, 2.5, 2.4, 1.9, 1}; anciens coefs


	Vertex* (shipVertices[]) = {tieFVertices, tieIVertices, tydiVertices, xWingVertices,	yWingVertices,	faucVertices,	planeVertices, f14Vertices,	rafVertices, deltaVertices,	NULL, missileGVertices};
	short (shipNumVertices[]) = {TIEF_VERT_NB, TIEI_VERT_NB, TYDI_VERT_NB, XWING_VERT_NB, YWING_VERT_NB, FAUC_VERT_NB, PLANE_VERT_NB, F14_VERT_NB, RAF_VERT_NB, DELTA_VERT_NB, 0, MISSG_VERT_NB};
	Line* (shipLines[]) = {tieFLines,	tieILines,	tydiLines,	xWingLines, yWingLines,	faucLines,	planeLines, f14Lines,	rafLines, deltaLines,	NULL, missileGLines};
	short (shipNumLines[]) = {TIEF_LINES_NB, TIEI_LINES_NB, TYDI_LINES_NB, XWING_LINES_NB, YWING_LINES_NB, FAUC_LINES_NB, PLANE_LINES_NB, F14_LINES_NB, RAF_LINES_NB, DELTA_LINES_NB, 0, MISSG_LINES_NB};
	short* (shipEnds[]) = {tieFEnds, tieIEnds,	tydiEnds, xWingEnds, yWingEnds, faucEnds,	planeEnds,	f14Ends,	rafEnds,	deltaEnds,	NULL, missileGEnds};
	short* (shipCanons[]) = {tieFCanons, tieICanons, tydiCanons, xWingCanons, yWingCanons, faucCanons, planeCanons, f14Canons, rafCanons, deltaCanons, NULL};
	
	Angle* shipAng = NULL;
	Vertex* shipCentre = NULL;
	ScrPoint* ptrProj = NULL;

	Vertex *ptrExtShipV = NULL;
	Line   *ptrExtShipL = NULL; // pointeurs sur des espaces allous qui contiennet les infos sur un eventuel vaisseau externe
	
	short extShipEnds[9];
	short extShipCanons[2]; // tableaux qui contienent des donnes sur les vaisseaux externes (eux ne sont pas allous)

	short astState[5]; // etat des astroides
	short astPower[5]; // nombre de coups de laser (missiles) encaissable avant d'exploser

/**************************** Dfinition de l'astrode ****************************/  

// Definition des vertices (12)
#define AST_VERT_NB 12	
	Vertex astVertices[12] = {{-8,0,3},{-5,5,8},{5,5,8},{5,-5,8},{-5,-5,8},{-5,5,-8},{5,5,-8},{5,-5,-8},{-5,-5,-8},{8,3,0},{5,10,3},{5,10,-6}};
												
// Dfinition des lignes qui joignent les vertices (27)
#define AST_LINES_NB 27	
	Line astLines[27] = {{0,1},{0,4},{0,8},{0,5},
											{1,2},{2,3},{3,4},{4,1}, //
											{5,6},{6,7},{7,8},{8,5}, // Parallepipde central
											{1,5},{2,6},{3,7},{4,8}, //
											{9,3},{9,2},{9,10},{9,7},{9,6},{9,11},
											{10,1},{10,2},{11,5},{11,6},{10,11}};
		
	Angle astAng[5];
	Vertex astCentre[5];
	short astRay[5];							// dfinition polaire de la position de l'astroide dans le plan (x,y) en mode 'spiral'
	unsigned char astPolAng[5];		// (rayon et angle)
	
/***************************** Dfinition du droide kamikaze *************************

#define KAM_VERT_NB 11
	Vertex kamVertices[11] = {{0,4,0},{4,0,0},{0,-4,0},{-4,0,0},{0,0,4},{0,0,-4},{8,0,0},{-8,0,0},{0,12,0},{0,-8,4},{0,-12,0}};
											
// Dfinition des lignes qui joignent les vertices (14)
#define KAM_LINES_NB 20
	Line kamLines[20] = {{0,1},{0,3},{0,4},{0,5},{2,1},{2,3},{2,4},{2,9},{1,4},{4,3},{3,5},{5,1},{0,8},{4,8},{3,7},{7,5},{1,6},{6,5},{9,10},{10,5}};

***************************** Dfinition du kamikaze 2 ******************************/

// Definition des vertices (13)
#define KAM2_VERT_NB 13
	Vertex kam2Vertices[13] = {{0,5,0},{5,0,0},{0,-5,0},{-5,0,0},{0,0,5},{0,0,-5},{0,0,11},{8,15,8},{-8,15,8},{-15,0,8},{-8,-15,8},{8,-15,8},{15,0,8}};
											
// Dfinition des lignes qui joignent les vertices (23)
#define KAM2_LINES_NB 23
	Line kam2Lines[23] = 		{{0,4},{4,2},{2,5},{5,0}, 		//
													{0,1},{4,1},{2,1},{5,1}, 				// corps
													{0,3},{4,3},{2,3},{5,3}, 				//
													{5,6},			 				// bras
													{7,8},{8,9},{9,10},{10,11},{11,12},{12,7},{6,7},{6,8},{6,10},{6,11}};			// aile


/************************ Dfinition du fragment d'astroide ************************/

// Definition des vertices (4)
#define FRAG_VERT_NB 4
	Vertex fragVertices[4] = {{0,4,0},{-4,-4,4},{4,-4,4},{0,-4,-4}};
												
// Dfinition des lignes qui joignent les vertices (6)
#define FRAG_LINES_NB 6
	Line fragLines[6] = {{0,1},{0,2},{0,3},{1,2},{2,3},{3,1}};
	
	Angle fragAng[4] = {{15,80,120},{240,95,156},{145,23,100},{215, 89, 47}};
	Vertex fragCentre[4];
	short fragDist;
	
/**************************** Dfinition du morceau de tole ****************************/

// Definition des vertices (4)
	Vertex toleVertices[4] = {{-4,-4,0},{-4,4,0},{4,4,0},{4,-4,0}};
												
// Dfinition des lignes qui joignent les vertices (4)
	Line toleLines[4] = {{0,1},{1,2},{2,3},{3,0}};
											
	Angle toleAng[6] = {{15,80,120},{240,95,156},{145,23,100},{215, 89, 47},{212,5,98},{145, 130, 8}};
	Vertex toleCentre[6];

/**************************** Dfinition de la flche 3D ****************************/

// Definition des vertices (7)
	Vertex arrowVertices[7] = {{-6,3,0},{0,3,0},{0,5,0},{6,0,0},{0,-5,0},{0,-3,0},{-6,-3,0}};
											
// Dfinition des lignes qui joignent les vertices (7)
	Line arrowLines[7] = {{0,1},{1,2},{2,3},{3,4},{4,5},{5,6},{6,0}};
	
	// Definition des vertices (7)
	Vertex arrow2Vertices[7] = {{-12,6,0},{0,6,0},{0,10,0},{12,0,0},{0,-10,0},{0,-6,0},{-12,-6,0}};
											
	Angle arrowAng[2] = {{0,0,0},{0,128,0}};
	Vertex arrowCentre[2] = {{48,20,-10},{-48,20,-10}};

/***************************** Dfinition des missiles (lasers) ******************************/

// Dfinition du modle missile
// Definition des vertices (4)
#define MISS_VERT_NB 4
	Vertex missileVertices[4] = {{-1,0,3},{0,0,3},{-1,0,-3},{0,0,-3}};
											
// Dfinition des lignes qui joignent les vertices (4)
#define MISS_LINES_NB 4
	Line missileLines[4] = {{0,1},{1,2},{2,3},{3,0}};
	
	short missileEnds[] = {2, 2, 3};	// extrmits du missile (les deux points avants)

// Definition des caractristiques missiles : en tout MAX_MISSILES couple de missiles...
// on indice les couples de missiles de 0  n (n < MAX_MISSILES) 
// avec 0 l'indice du missile tir il y a le plus longtemps
// Quand un missile explose ou disparait, on dcale le reste du (des) tableaux de 1 vers la gauche

	Angle missileAng[MAX_MISSILES][2];
	Vertex missileCentre[MAX_MISSILES][2];
	Vertex missileVector[MAX_MISSILES];	// vecteur ajout  la position du centre du missile pour le faire avancer d'un pas
	short missileDist[MAX_MISSILES];	  // nombre de pas duquel les missiles on avanc parcourue par les missiles

/********************************** Trotoirs cosmiques ****************************************/

#define PATH_VERT_NB 3
	Vertex pathVertices[3] = {{-6,0,0},{6,0,0},{0,0,-32000}}; // le 4e point est le centre de l'cran apres projection
											
#define PATH_LINES_NB 3
	Line pathLines[3] = {{0,1},{0,2},{1,2}};
	
	Vertex pathCentre[2] = {{-50, -10, 0}, {50, -10, 0}};
		
/*	Vertex pathLinesVertices[2] = {{-5,0,0},{5,0,0}};
	Line pathLinesLines[1] = {{0,1}};
	
	short pathLinesZ[5];	// tableau qui stocke les z des lignes des trottoirs cosmiques */

/*************************************** Anneaux ***********************************************/
#define RING_VERT_NB 12
	Vertex ringVertices[12] = {{0,50,0},{25,43,0},{43,25,0},{50,0,0},{43,-25,0},{25,-43,0},{0,-50,0},{-25,-43,0},{-43,-25,0},{-50,0,0},{-43,25,0},{-25,43,0}};
											
#define RING_LINES_NB 12
	Line ringLines[12] = {{0,1},{1,2},{2,3},{3,4},{4,5},{5,6},{6,7},{7,8},{8,9},{9,10},{10,11},{11,0}};
